clear all
delta=10^(-12);
zd= 1i*delta/(1*(2-1i*delta));

distance =1.5;%1.5
re=2.5;%2.5
ri=0.4;%0.4

alp = 1;

t=1;

xii=-log(0.2); %0.2, 0.5, 0.55
xie=-log(0.70);

AAA=1;
CCC=1;
bx=3;by=3;
xx=5+5*1i;
zz=CCC*(xx+alp)/(xx-alp);
xi0 = real(log(zz));
th0 = imag(log(zz));




ri=exp(-xii);
re=exp(-xie);
 
N=200;

fp=zeros(1,N);fm=zeros(1,N);
ap=zeros(1,N);am=zeros(1,N);
bp=zeros(1,N);bm=zeros(1,N);
cp=zeros(1,N);cm=zeros(1,N);
dp=zeros(1,N);dm=zeros(1,N);


for j=1:N
    fp(j)=AAA*(1+1*1i)/(4*pi*alp)/2*(bx-1i*by)*(1-exp(-xi0-1i*th0))*(-1+exp(xi0+1i*th0))*exp(-(j)*(xi0+1i*th0));
    fm(j)=AAA*(1+1*1i)/(4*pi*alp)/2*(bx+1i*by)*(1-exp(-xi0+1i*th0))*(-1+exp(xi0-1i*th0))*exp((j)*(-xi0+1i*th0));
    
    
    ap(j)=zd *(exp(-2*j*xie)-exp(-2*j*xii))/(zd^2-exp(-2*j*(xii-xie)))*fp(j);
    am(j)=zd *(exp(-2*j*xie)-exp(-2*j*xii))/(zd^2-exp(-2*j*(xii-xie)))*fm(j);
    bp(j)=(zd+  exp(-2*j*(xii-xie))  )/(zd^2-exp(-2*j*(xii-xie)))*fp(j);
    bm(j)=(zd+  exp(-2*j*(xii-xie))  )/(zd^2-exp(-2*j*(xii-xie)))*fm(j);
    cp(j)=(  -(1+zd)*exp(-2*j*xii)  )/(zd^2-exp(-2*j*(xii-xie)))*fp(j);
    cm(j)=(  -(1+zd)*exp(-2*j*xii)  )/(zd^2-exp(-2*j*(xii-xie)))*fm(j);
    dp(j)=(-1+  exp(-2*j*(xii-xie))  )/(zd^2-exp(-2*j*(xii-xie)))*fp(j);
    dm(j)=(-1+  exp(-2*j*(xii-xie))  )/(zd^2-exp(-2*j*(xii-xie)))*fm(j);
end
f0=AAA*(1+1*1i)/(4*pi*alp)/2*real((bx-1i*by)*(-1)*(1-exp(-xi0-1i*th0)));
a0=-sum(ap)-sum(am);




t=35/5;
Xrange_min=-t+1; Xrange_max=t+1;
Yrange_min=-t; Yrange_max=t;


stepSize=(Xrange_max-Xrange_min)/200;

[XX YY] = meshgrid(Xrange_min:stepSize:Xrange_max, Yrange_min:stepSize:Yrange_max);
YY = flipud(YY);
VF = zeros(size(XX)); 
VF1 = zeros(size(XX));



[R C] = size(VF);
for c=1:C
    for r=1:R

        Bx=XX(1,c)+1i*YY(r,1);
        zeta=log(CCC*(Bx+alp)/(Bx-alp));%3.9, 12.0
        xi=real(zeta);
        th=imag(zeta);               
        if xi > -xie 
        for j=1:N
            VF(r,c) = VF(r,c)+ap(j)*exp(-j*xi+1i*j*th)+am(j)*exp(-j*xi+1i*(-j)*th);
        end
        end
        
        if (xi>-xii)&&(xi <= -xie)
        for j=1:N
            VF(r,c) = VF(r,c)+bp(j)*exp(j*xi+1i*j*th)+bm(j)*exp(j*xi+1i*(-j)*th);
            VF(r,c) = VF(r,c)+cp(j)*exp(-j*xi+1i*j*th)+cm(j)*exp(-j*xi+1i*(-j)*th);            
        end
        end
        
        if xi <= -xii
        for j=1:N
            VF(r,c) = VF(r,c)+dp(j)*exp(j*xi+1i*j*th)+dm(j)*exp(j*xi+1i*(-j)*th);
        end 
        end
        
        dipole=AAA*(1+1*1i)/(4*pi)*real((bx-1i*by)/(Bx-xx));
        if abs(dipole) < 200
        VF(r,c) = VF(r,c) + 1.0*dipole;
        VF1(r,c) = VF1(r,c) + 1*dipole;
        end
        
        
       
    end
        
    
    
end

% energy

sum=0;
for j=1:N
    sum=sum+ j*( abs(bp(j))^2*exp(-2*j*xie) + abs(cp(j))^2*exp(2*j*xii)  );
    sum=sum+ j*( abs(bm(j))^2*exp(-2*j*xie) + abs(cm(j))^2*exp(2*j*xii)  );
end

VF=VF/sqrt(delta*sum)/1;





trun=9;


max_trun = trun;
min_trun = -trun;
for c=1:C
    for r=1:R
        if (real(VF(r,c)) > max_trun) 
       VF(r,c) = 1*max_trun;
       
       else if (real(VF(r,c)) < min_trun)
       VF(r,c) = 1*min_trun;
            end
       end
       
    end
end




figure(12)



[hC hC]=contourf(XX,YY,real(VF),50,'LineWidth',0.2);
set(gcf, 'Renderer', 'opengl')

center_c=alp/tanh((xii-3*xie)/2);
r_c=alp/sinh((xii-3*xie)/2);




center_i=alp/tanh((-xii));
r_i=alp/sinh((xii));
circles(center_i,0,r_i,'facecolor','none','edgecolor','white','linewidth',1.7);

center_e=alp/tanh((-xie));
r_e=alp/sinh((xie));
circles(center_e,0,r_e,'facecolor','none','edgecolor','white','linewidth',1.7);

center_dipole_x=real(xx);
center_dipole_y=imag(xx);
circles(center_dipole_x,center_dipole_y,0.2,'facecolor','white','edgecolor','none');

hold on
thetatemp=0:0.05*pi:2*pi;
rc=abs(r_c);
plot(rc*(cos(thetatemp))+center_c,rc*sin(thetatemp),'--','Color','white','linewidth',1.7);

axis([-t+1,t+1,-t,t])

colormap(jet)
set(figure(12), 'Position', [200 500 350/1.0 350/1.0])
hold off


